#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <wait.h>
#include <string.h>
#include "wisio.h"
#include "Wtext.h"
// ** CLASS: textbase
void textbase::init(int pcid)
{
    
//-     CLEAR(scr);
     CLEAR(mod);
     CLEAR(lines);
     CLEAR(pstredit);
     topline = 0;
     newtop = 0;
}

int textbase::toidx(int row)
{
   int idx;
   idx =(row -1+topline)%rows;
   if (idx <0 )
       idx += rows;
   return(idx);
}

void textbase::scroll(int lines)
{
  char scr1[1024];
  memset(scr1,0,256);
  if (lines > 0)
     for (;lines>0;lines--)                           /* Go down lines */
     {
        putline(1,scr1);
//      memset(scr1[topline],0,256);
        setstatus(1,2);
        topline ++;
        if (topline>=rows)
           topline=0;
        newtop=1;
    }
  else
     for (;lines<0;lines++)                           /* Go down lines */
     {
        topline --;
        if (topline<0)
           topline=rows-1;
        putline(1,scr1);
//      memset(scr1[topline],0,256);
//        mod[topline]=2;
        setstatus(1,2);
        newtop=1;
    }
}

int textbase::getline(int row, char *str)
{
   int idx; 
   if( row<1  || row > rows)
      return 0;
   idx=toidx(row);
   if (!pstredit[idx])
   {
      memset(str,0,cols);
      return 0;
   }
   pstredit[idx]->read(NULL,0,str,cols);
//   strncpy(str,scr[toidx(row)],cols);
   return strlen(str);
   
}

void textbase::putline(int row, char *str)
{
   int idx; 
   if( row<1  || row > rows)
      return;
   idx=toidx(row);
//-   strncpy(scr[idx],str,cols);
   mod[idx] = 1;
   if (!pstredit[idx])
      pstredit[idx] = new(tStrEditobj);
   pstredit[idx]->write(NULL,0,str,cols);
      
}

tStrEditobj *textbase::getobj(int row)
{
   int idx; 
   if( row<1  || row > rows)
      return NULL;
   idx=toidx(row);
   return pstredit[idx];
}

int textbase::setstatus(int row, int status)
{
     if( row>0  && row <= rows)
        mod[toidx(row)]=status;
     if (!row)
        newtop =status;
}

int textbase::getstatus(int row)
{
     if (row)
        return mod[toidx(row)];
     else
        return newtop;
}

int textbase::setcid(int row, int ucid)
{
     if( row>0  && row <= rows)
        lines[toidx(row)]=ucid;
}

int textbase::getcid(int row)
{
     if (row)
        return lines[toidx(row)];
     else
        return lines[0];
}

void textbase::clear()
{
   int i;
   for ( i= 0 ;i<rows; i++)
   {
      mod[i]=2;
   }
}


// ** CLASS: textobj
void textobj::setfont(char *setfont, int width, int height)
{
     font = Wgetbm(setfont);
     sizex = width;
     sizey = height;
}

void textobj::setsize(int width, int height)
{
     cols = width;
     rows = height;
}

void textobj::setcolor(int textcolor, int textbackground)
{
     color = textcolor;
     bgcolor = textbackground;
}

void textobj::init(int pcid)
{
     int winc,i;
  
     textbase::init(pcid);  
     cursor = 0;
     add_rect(CMD_PUTBAR,pcid,0,0,0,cols*sizex,rows*sizey,bgcolor);
     Wsetctl(pcid,SETCTL_BGCOLOR_D,bgcolor,0);
     for ( i= 1 ;i<=rows; i++)
     {
         setcid(i,Wcreate_ctrl(MAINQUE,pcid,0,0,sizey*(i-1),cols*sizex,sizey,81,NULL));
         Wsetctl(getcid(i),SETCTL_BGCOLOR_D,bgcolor,0);
     }
     Wdel_ctrl(MAINQUE,pcid,0,1);                                            /* REMOVE BACKGROUD */
}

void textobj::showcurs(int state, int col, int row)
{
    switch(state)
    {
    case 0:
       cursor =0;
       add_rect(CMD_PUTCUR,0,0,0,0,0,0,0);
       break;
    case 1:
       cursor =1;
    default:
       if (cursor)
          add_rect(CMD_PUTCUR,getcid(row),0,sizex*col,7,8,2,color);
       break;   
    }
}

void textobj::update()
{
     int i;
     char linebuff[1024];
     if (getstatus(0))
        update_ctrl();
     for ( i= 1 ;i<=rows; i++)
        if (getstatus(i))
        { 
           setstatus(i,0);
           getline(i,linebuff);
           linebuff[cols]=0;
           add_text(CMD_PUTTXT,getcid(i),0,font,0,0,sizex,0,color,linebuff);
           Wdel_ctrl(MAINQUE,getcid(i),strlen(linebuff),cols);
        }

}

void textobj::update_ctrl()
{
     int i;
           
     for ( i= 1 ;i<=rows; i++)
     {  
        if (getstatus(i) == 2)
           Wdel_ctrl(MAINQUE,getcid(i),1,MAXDIMVAL);
        Wput_ctrl(MAINQUE,getcid(i),WIN_CTRL,0,sizey*(i-1),cols*sizex,sizey);
     }
     setstatus(0,0);
     
}

