#include "list.h"
#include "stdlib.h"

LIST *new_list()
{
    LIST *ret;
    
    ret = malloc(sizeof(LIST));
    memset(ret,0,sizeof(LIST));
    return ret;
    
}

void *add_list(LIST *list,int size)
{
    LISTNODE *ret,*next;
    ret = malloc(size+sizeof(LISTNODE));
    if (!ret)
       return NULL;
    if (!list->pointer)
    {
       ret->next = list->first;
       ret->previous = NULL;
/*       list->first->previous = ret;*/
       list->first = ret;
    }   
    else
    {
       ret->previous = list->pointer;
       ret->next = list->pointer->next;
       next = list->pointer->next;
       if (next)
          next->previous = ret;
       list->pointer->next = ret;
    }
    list->nodes++;
    list->position++;
    list->pointer = ret;
    return ret;
}


int put_list(LIST *list,void *node)
{
    
}

int del_list(LIST *list)
{
    LISTNODE *del,*prev,*next;
    
    if(!list->position)
       return -1;
    del = list->pointer;
    prev=del->previous;
    next=del->next;
    if (prev)                      /* Middle of the list */
    {
        prev->next = next;
        if (next)
           next->previous = prev;
        else 
           list->last = prev;
    }
    else
    {
       list->first = next;
       if (next)
          next->previous = NULL;
    }
    list->nodes --;
    list->pointer = next;
    free(del);
}

int set_list(LIST *list,int position)
{   
    LISTNODE *pointer;
    int curpos;
    
    if(position<=0 || position>list->nodes)
    { 
       list->pointer = NULL;
       list->position = 0;
       return 0;
    }
    if (list->pointer)
    {
       pointer = list->pointer;
       curpos  = list->position;
    }
    else if (list->first)
    {
       pointer =  list->first;
       curpos = 1;  
    }  
    else
       return 0;
    while (position>curpos && pointer->next)
    {
       pointer = pointer->next;
       curpos++;
    }
    while (position<curpos && pointer->previous)
    {
       pointer = pointer->previous;
       curpos--;
    }
    list->position=curpos;
    list->pointer = pointer;
    return curpos;
}

void *get_list(LIST *list, int relative)
{
    if (set_list(list,list->position+relative))
       return list->pointer;
    else
       return NULL;
}

int list_pos(LIST *list)
{
    return list->position;
}

int list_nodes(LIST *list)
{
    return list->nodes;
}

int free_list(LIST *list)
{
    set_list(list,0);
    while (get_list(list,1))
       del_list(list);
    free(list);    
}



